/[gentoo-x86]/eclass/gnome2.eclass
Gentoo

Diff of /eclass/gnome2.eclass

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

Revision 1.76 Revision 1.119
1# Copyright 1999-2004 Gentoo Foundation 1# Copyright 1999-2013 Gentoo Foundation
2# Distributed under the terms of the GNU General Public License v2 2# Distributed under the terms of the GNU General Public License v2
3# $Header: /var/cvsroot/gentoo-x86/eclass/gnome2.eclass,v 1.76 2006/12/07 03:13:25 compnerd Exp $ 3# $Header: /var/cvsroot/gentoo-x86/eclass/gnome2.eclass,v 1.119 2013/01/16 22:52:37 eva Exp $
4 4
5# GNOME 2 ECLASS 5# @ECLASS: gnome2.eclass
6inherit libtool gnome.org debug fdo-mime eutils 6# @MAINTAINER:
7# gnome@gentoo.org
8# @BLURB: Provides phases for Gnome/Gtk+ based packages.
9# @DESCRIPTION:
10# Exports portage base functions used by ebuilds written for packages using the
11# GNOME framework. For additional functions, see gnome2-utils.eclass.
7 12
13inherit eutils fdo-mime libtool gnome.org gnome2-utils
14
15case "${EAPI:-0}" in
16 0|1)
17 EXPORT_FUNCTIONS src_unpack src_compile src_install pkg_preinst pkg_postinst pkg_postrm
18 ;;
19 2|3|4|5)
20 EXPORT_FUNCTIONS src_unpack src_prepare src_configure src_compile src_install pkg_preinst pkg_postinst pkg_postrm
21 ;;
22 *) die "EAPI=${EAPI} is not supported" ;;
23esac
24
25# @ECLASS-VARIABLE: G2CONF
26# @DEFAULT_UNSET
27# @DESCRIPTION:
8# Extra configure opts passed to econf 28# Extra configure opts passed to econf
9G2CONF=${G2CONF:=""} 29G2CONF=${G2CONF:-""}
10 30
31# @ECLASS-VARIABLE: GNOME2_LA_PUNT
32# @DESCRIPTION:
33# Should we delete ALL the .la files?
34# NOT to be used without due consideration.
35if has ${EAPI:-0} 0 1 2 3 4; then
36 GNOME2_LA_PUNT=${GNOME2_LA_PUNT:-"no"}
37else
38 GNOME2_LA_PUNT=${GNOME2_LA_PUNT:-""}
39fi
40
41# @ECLASS-VARIABLE: ELTCONF
42# @DEFAULT_UNSET
43# @DESCRIPTION:
11# Extra options passed to elibtoolize 44# Extra options passed to elibtoolize
12ELTCONF=${ELTCONF:=""} 45ELTCONF=${ELTCONF:-""}
13 46
47# @ECLASS-VARIABLE: USE_EINSTALL
48# @DEFAULT_UNSET
49# @DESCRIPTION:
14# Should we use EINSTALL instead of DESTDIR 50# Should we use EINSTALL instead of DESTDIR. DEPRECATED
15USE_EINSTALL=${USE_EINSTALL:=""} 51USE_EINSTALL=${USE_EINSTALL:-""}
16 52
17# Run scrollkeeper for this package? 53# @ECLASS-VARIABLE: SCROLLKEEPER_UPDATE
54# @DESCRIPTION:
55# Whether to run scrollkeeper for this package or not. DEPRECATED
18SCROLLKEEPER_UPDATE=${SCROLLKEEPER_UPDATE:="1"} 56SCROLLKEEPER_UPDATE=${SCROLLKEEPER_UPDATE:-"1"}
19 57
20# Where to put scrollkeeper data lives 58# @ECLASS-VARIABLE: DOCS
21SCROLLKEEPER_DIR=${SCROLLKEEPER_DIR:="/var/lib/scrollkeeper"} 59# @DEFAULT_UNSET
60# @DESCRIPTION:
61# String containing documents passed to dodoc command.
22 62
23# Path to scrollkeeper-update 63# @ECLASS-VARIABLE: GCONF_DEBUG
24SCROLLKEEPER_UPDATE_BIN=${SCROLLKEEPER_UPDATE_BIN:="${ROOT}/usr/bin/scrollkeeper-update"} 64# @DEFAULT_UNSET
65# @DESCRIPTION:
66# Whether to handle debug or not.
67# Some gnome applications support various levels of debugging (yes, no, minimum,
68# etc), but using --disable-debug also removes g_assert which makes debugging
69# harder. This variable should be set to yes for such packages for the eclass
70# to handle it properly. It will enable minimal debug with USE=-debug.
71# Note that this is most commonly found in configure.ac as GNOME_DEBUG_CHECK.
25 72
26# Path to gconftool-2
27GCONFTOOL_BIN=${GCONFTOOL_BIN:="${ROOT}/usr/bin/gconftool-2"}
28 73
29if [[ ${GCONF_DEBUG} != "no" ]]; then 74if [[ ${GCONF_DEBUG} != "no" ]]; then
30 IUSE="debug" 75 IUSE="debug"
31fi 76fi
32 77
33DEPEND=">=sys-apps/sed-4"
34 78
79# @FUNCTION: gnome2_src_unpack
80# @DESCRIPTION:
81# Stub function for old EAPI.
35gnome2_src_unpack() { 82gnome2_src_unpack() {
36 unpack ${A} 83 unpack ${A}
37 cd ${S} 84 cd "${S}"
85 has ${EAPI:-0} 0 1 && gnome2_src_prepare
86}
87
88# @FUNCTION: gnome2_src_prepare
89# @DESCRIPTION:
90# Prepare environment for build, fix build of scrollkeeper documentation,
91# run elibtoolize.
92gnome2_src_prepare() {
93 # Prevent assorted access violations and test failures
94 gnome2_environment_reset
38 95
39 # Prevent scrollkeeper access violations 96 # Prevent scrollkeeper access violations
40 gnome2_omf_fix 97 gnome2_omf_fix
41}
42 98
99 # Disable all deprecation warnings
100 gnome2_disable_deprecation_warning
101
102 # Run libtoolize
103 if has ${EAPI:-0} 0 1 2 3; then
104 elibtoolize ${ELTCONF}
105 else
106 # Everything is fatal EAPI 4 onwards
107 nonfatal elibtoolize ${ELTCONF}
108 fi
109
110}
111
112# @FUNCTION: gnome2_src_configure
113# @DESCRIPTION:
114# Gnome specific configure handling
43gnome2_src_configure() { 115gnome2_src_configure() {
44 # Update the GNOME configuration options 116 # Update the GNOME configuration options
45 if [[ ${GCONF_DEBUG} != 'no' ]] ; then 117 if [[ ${GCONF_DEBUG} != 'no' ]] ; then
46 if use debug ; then 118 if use debug ; then
47 G2CONF="${G2CONF} --enable-debug=yes" 119 G2CONF="--enable-debug=yes ${G2CONF}"
48 fi
49 fi 120 fi
121 fi
50 122
51 # Prevent a QA warning 123 # Starting with EAPI=5, we consider packages installing gtk-doc to be
52 if hasq doc ${IUSE} ; then 124 # handled by adding DEPEND="dev-util/gtk-doc-am" which provides tools to
125 # relink URLs in documentation to already installed documentation.
126 # This decision also greatly helps with constantly broken doc generation.
127 # Remember to drop 'doc' USE flag from your package if it was only used to
128 # rebuild docs.
129 # Preserve old behavior for older EAPI.
130 if grep -q "enable-gtk-doc" ${ECONF_SOURCE:-.}/configure ; then
131 if has ${EAPI:-0} 0 1 2 3 4 && has doc ${IUSE} ; then
53 G2CONF="${G2CONF} $(use_enable doc gtk-doc)" 132 G2CONF="$(use_enable doc gtk-doc) ${G2CONF}"
133 else
134 G2CONF="--disable-gtk-doc ${G2CONF}"
54 fi 135 fi
136 fi
55 137
56 # Run libtoolize 138 # Pass --disable-maintainer-mode when needed
57 elibtoolize ${ELTCONF} 139 if grep -q "^[[:space:]]*AM_MAINTAINER_MODE(\[enable\])" \
140 ${ECONF_SOURCE:-.}/configure.*; then
141 G2CONF="--disable-maintainer-mode ${G2CONF}"
142 fi
58 143
59 # Do not remove the addwrite. bug #128289 144 # Pass --disable-scrollkeeper when possible
60 addwrite "${ROOT}/root/.gnome2" 145 if grep -q "disable-scrollkeeper" ${ECONF_SOURCE:-.}/configure; then
146 G2CONF="--disable-scrollkeeper ${G2CONF}"
147 fi
61 148
62 # GST_REGISTRY is to work around gst-inspect trying to read/write /root 149 # Pass --disable-silent-rules when possible (not needed for eapi5), bug #429308
63 GST_REGISTRY="${S}/registry.xml" econf "$@" ${G2CONF} || die "configure failed" 150 if has ${EAPI:-0} 0 1 2 3 4; then
64} 151 if grep -q "disable-silent-rules" ${ECONF_SOURCE:-.}/configure; then
152 G2CONF="--disable-silent-rules ${G2CONF}"
153 fi
154 fi
65 155
156 # Pass --disable-schemas-install when possible
157 if grep -q "disable-schemas-install" ${ECONF_SOURCE:-.}/configure; then
158 G2CONF="--disable-schemas-install ${G2CONF}"
159 fi
160
161 # Pass --disable-schemas-compile when possible
162 if grep -q "disable-schemas-compile" ${ECONF_SOURCE:-.}/configure; then
163 G2CONF="--disable-schemas-compile ${G2CONF}"
164 fi
165
166 # Avoid sandbox violations caused by gnome-vfs (bug #128289 and #345659)
167 addwrite "$(unset HOME; echo ~)/.gnome2"
168
169 econf ${G2CONF} "$@"
170}
171
172# @FUNCTION: gnome2_src_compile
173# @DESCRIPTION:
174# Stub function for old EAPI.
66gnome2_src_compile() { 175gnome2_src_compile() {
67 gnome2_src_configure "$@" 176 has ${EAPI:-0} 0 1 && gnome2_src_configure "$@"
68 emake || die "compile failure" 177 emake || die "compile failure"
69} 178}
70 179
180# @FUNCTION: gnome2_src_install
181# @DESCRIPTION:
182# Gnome specific install. Handles typical GConf and scrollkeeper setup
183# in packages and removal of .la files if requested
71gnome2_src_install() { 184gnome2_src_install() {
185 has ${EAPI:-0} 0 1 2 && ! use prefix && ED="${D}"
72 # if this is not present, scrollkeeper-update may segfault and 186 # if this is not present, scrollkeeper-update may segfault and
73 # create bogus directories in /var/lib/ 187 # create bogus directories in /var/lib/
74 dodir "${SCROLLKEEPER_DIR}" 188 local sk_tmp_dir="/var/lib/scrollkeeper"
189 dodir "${sk_tmp_dir}" || die "dodir failed"
75 190
76 # we must delay gconf schema installation due to sandbox 191 # we must delay gconf schema installation due to sandbox
77 export GCONF_DISABLE_MAKEFILE_SCHEMA_INSTALL="1" 192 export GCONF_DISABLE_MAKEFILE_SCHEMA_INSTALL="1"
78 193
79 debug-print "You are testing with DESTDIR by default - AllanonJL"
80 if [[ -z "${USE_EINSTALL}" || "${USE_EINSTALL}" = "0" ]]; then 194 if [[ -z "${USE_EINSTALL}" || "${USE_EINSTALL}" = "0" ]]; then
195 debug-print "Installing with 'make install'"
81 make DESTDIR=${D} "scrollkeeper_localstate_dir=${D}${SCROLLKEEPER_DIR} " "$@" install || die "install failed" 196 emake DESTDIR="${D}" "scrollkeeper_localstate_dir=${ED}${sk_tmp_dir} " "$@" install || die "install failed"
82 else 197 else
198 debug-print "Installing with 'einstall'"
83 einstall "scrollkeeper_localstate_dir=${D}${SCROLLKEEPER_DIR} " "$@" || die "einstall failed" 199 einstall "scrollkeeper_localstate_dir=${ED}${sk_tmp_dir} " "$@" || die "einstall failed"
84 fi 200 fi
85 201
86 unset GCONF_DISABLE_MAKEFILE_SCHEMA_INSTALL 202 unset GCONF_DISABLE_MAKEFILE_SCHEMA_INSTALL
87 203
204 # Handle documentation as 'default' for eapi5 and newer, bug #373131
205 if has ${EAPI:-0} 0 1 2 3 4; then
88 # Manual document installation 206 # Manual document installation
207 if [[ -n "${DOCS}" ]]; then
208 dodoc ${DOCS} || die "dodoc failed"
209 fi
210 else
211 if ! declare -p DOCS >/dev/null 2>&1 ; then
212 local d
213 for d in README* ChangeLog AUTHORS NEWS TODO CHANGES THANKS BUGS \
214 FAQ CREDITS CHANGELOG ; do
89 [[ -n "${DOCS}" ]] && dodoc ${DOCS} 215 [[ -s "${d}" ]] && dodoc "${d}"
216 done
217 elif declare -p DOCS | grep -q '^declare -a' ; then
218 dodoc "${DOCS[@]}"
219 else
220 dodoc ${DOCS}
221 fi
222 fi
90 223
91 # Do not keep /var/lib/scrollkeeper because: 224 # Do not keep /var/lib/scrollkeeper because:
92 # 1. scrollkeeper will get regenerated at pkg_postinst() 225 # 1. The scrollkeeper database is regenerated at pkg_postinst()
93 # 2. ${D}/var/lib/scrollkeeper contains only indexes for the current pkg 226 # 2. ${ED}/var/lib/scrollkeeper contains only indexes for the current pkg
94 # thus it makes no sense if pkg_postinst ISN'T run for some reason. 227 # thus it makes no sense if pkg_postinst ISN'T run for some reason.
95 228 rm -rf "${ED}${sk_tmp_dir}"
96 if [[ -z "$(find ${D} -name '*.omf')" ]]; then 229 rmdir "${ED}/var/lib" 2>/dev/null
97 export SCROLLKEEPER_UPDATE="0" 230 rmdir "${ED}/var" 2>/dev/null
98 fi
99
100 # Regenerate these in pkg_postinst()
101 rm -rf "${D}${SCROLLKEEPER_DIR}"
102 231
103 # Make sure this one doesn't get in the portage db 232 # Make sure this one doesn't get in the portage db
104 rm -fr "${D}/usr/share/applications/mimeinfo.cache" 233 rm -fr "${ED}/usr/share/applications/mimeinfo.cache"
105}
106 234
107 235 # Delete all .la files
108gnome2_gconf_install() { 236 if has ${EAPI:-0} 0 1 2 3 4; then
109 237 if [[ "${GNOME2_LA_PUNT}" != "no" ]]; then
110 if [[ -x ${GCONFTOOL_BIN} ]]; then 238 ebegin "Removing .la files"
111 # We are ready to install the GCONF Scheme now 239 if ! { has static-libs ${IUSE//+} && use static-libs; }; then
112 unset GCONF_DISABLE_MAKEFILE_SCHEMA_INSTALL 240 find "${D}" -name '*.la' -exec rm -f {} + || die "la file removal failed"
113 export GCONF_CONFIG_SOURCE=$(${GCONFTOOL_BIN} --get-default-source)
114
115 einfo "Installing GNOME 2 GConf schemas"
116
117 local contents="${ROOT}/var/db/pkg/*/${PN}-${PVR}/CONTENTS"
118
119 for F in $(grep "^obj /etc/gconf/schemas/.\+\.schemas\b" ${contents} | gawk '{print $2}' ); do
120 if [[ -e "${F}" ]]; then
121 # echo "DEBUG::gconf install ${F}"
122 ${GCONFTOOL_BIN} --makefile-install-rule ${F} 1>/dev/null
123 fi 241 fi
124 done
125
126 # have gconf reload the new schemas
127 ebegin "Reloading GConf schemas"
128 killall -HUP gconfd-2
129 eend $?
130 fi
131
132}
133
134gnome2_gconf_uninstall() {
135 if [[ -x ${GCONFTOOL_BIN} ]]; then
136 unset GCONF_DISABLE_MAKEFILE_SCHEMA_INSTALL
137 export GCONF_CONFIG_SOURCE=$(${GCONFTOOL_BIN} --get-default-source)
138
139 einfo "Uninstalling GNOME 2 GConf schemas"
140
141 local contents="${ROOT}/var/db/pkg/*/${PN}-${PVR}/CONTENTS"
142
143 for F in $(grep "obj /etc/gconf/schemas" ${contents} | sed 's:obj \([^ ]*\) .*:\1:' ); do
144 # echo "DEBUG::gconf install ${F}"
145 ${GCONFTOOL_BIN} --makefile-uninstall-rule ${F} 1>/dev/null
146 done
147 fi
148}
149
150gnome2_icon_cache_update() {
151 local updater=$(type -p gtk-update-icon-cache 2> /dev/null)
152
153 ebegin "Updating icons cache"
154
155 if [[ ! -x ${updater} ]] ; then
156 debug-print "${updater} is not executable"
157
158 # We failed to run
159 eend 1 242 eend
160
161 return
162 fi
163
164 if ! grep -q "obj /usr/share/icons" ${ROOT}/var/db/pkg/*/${PF}/CONTENTS
165 then
166 debug-print "No items to update"
167
168 # We are done successfully
169 eend 0
170
171 return
172 fi
173
174 local retval=0
175 local fails=( )
176
177 for dir in $(find ${ROOT}/usr/share/icons -maxdepth 1 -mindepth 1 -type d)
178 do
179 if [[ -f "${dir}/index.theme" ]] ; then
180 local rv=0
181
182 ${updater} -qf ${dir}
183 rv=$?
184
185 if [[ ! $rv -eq 0 ]] ; then
186 debug-print "Updating cache failed on ${dir}"
187
188 # Add to the list of failures
189 fails[$(( ${#fails[@]} + 1 ))]=$dir
190
191 retval=2
192 fi 243 fi
244 else
245 case "${GNOME2_LA_PUNT}" in
246 yes) prune_libtool_files --modules;;
247 no) ;;
248 *) prune_libtool_files;;
249 esac
193 fi 250 fi
194 done
195
196 eend ${retval}
197
198 for (( i = 0 ; i < ${#fails[@]} ; i++ )) ; do
199 ### HACK!! This is needed until bash 3.1 is unmasked.
200 ## The current stable version of bash lists the sizeof fails to be 1
201 ## when there are no elements in the list because it is declared local.
202 ## In order to prevent the declaration from being in global scope, we
203 ## this hack to prevent an empty error message being printed for stable
204 ## users. -- compnerd && allanonjl
205 if [[ "${fails[i]}" != "" && "${fails[i]}" != "()" ]] ; then
206 eerror "Failed to update cache with icon ${fails[i]}"
207 fi
208 done
209} 251}
210 252
211gnome2_omf_fix() { 253# @FUNCTION: gnome2_pkg_preinst
212 # workaround/patch against omf.make or omf-install/Makefile.in 254# @DESCRIPTION:
213 # in order to remove redundant scrollkeeper-updates. 255# Finds Icons, GConf and GSettings schemas for later handling in pkg_postinst
214 # - <liquidx@gentoo.org> 256gnome2_pkg_preinst() {
215 257 gnome2_gconf_savelist
216 local omf_makefiles filename 258 gnome2_icon_savelist
217 259 gnome2_schemas_savelist
218 omf_makefiles="$@" 260 gnome2_scrollkeeper_savelist
219
220 if [[ -f ${S}/omf-install/Makefile.in ]] ; then
221 omf_makefiles="${omf_makefiles} ${S}/omf-install/Makefile.in"
222 fi
223
224 # FIXME: does this really work? because omf.make only gets included
225 # when autoconf/automake is run. You should directly patch
226 # the Makefile.in's
227
228 if [[ -f ${S}/omf.make ]] ; then
229 omf_makefiles="${omf_makefiles} ${S}/omf.make"
230 fi
231
232 # testing fixing of all makefiles found
233 for filename in $(find ./ -name "Makefile.in" -o -name "Makefile.am") ; do
234 omf_makefiles="${omf_makefiles} ${filename}"
235 done
236
237 ebegin "Fixing OMF Makefiles"
238
239 local retval=0
240 local fails=( )
241
242 for omf in ${omf_makefiles} ; do
243 local rv=0
244
245 sed -i -e 's:scrollkeeper-update:true:' ${omf}
246 retval=$?
247
248 if [[ ! $rv -eq 0 ]] ; then
249 debug-print "updating of ${omf} failed"
250
251 # Add to the list of failures
252 fails[$(( ${#fails[@]} + 1 ))]=$omf
253
254 retval=2
255 fi
256 done
257
258 eend $retval
259
260 for (( i = 0 ; i < ${#fails[@]} ; i++ )) ; do
261 ### HACK!! This is needed until bash 3.1 is unmasked.
262 ## The current stable version of bash lists the sizeof fails to be 1
263 ## when there are no elements in the list because it is declared local.
264 ## In order to prevent the declaration from being in global scope, we
265 ## this hack to prevent an empty error message being printed for stable
266 ## users. -- compnerd && allanonjl
267 if [[ "${fails[i]}" != "" && "${fails[i]}" != "()" ]] ; then
268 eerror "Failed to update OMF Makefile ${fails[i]}"
269 fi
270 done
271} 261}
272 262
273gnome2_scrollkeeper_update() { 263# @FUNCTION: gnome2_pkg_postinst
274 if [[ -x ${SCROLLKEEPER_UPDATE_BIN} && "${SCROLLKEEPER_UPDATE}" = "1" ]] 264# @DESCRIPTION:
275 then 265# Handle scrollkeeper, GConf, GSettings, Icons, desktop and mime
276 einfo "Updating scrollkeeper database ..." 266# database updates.
277 ${SCROLLKEEPER_UPDATE_BIN} -q -p ${ROOT}${SCROLLKEEPER_DIR}
278 fi
279}
280
281gnome2_pkg_postinst() { 267gnome2_pkg_postinst() {
282 gnome2_gconf_install 268 gnome2_gconf_install
283 gnome2_scrollkeeper_update
284 fdo-mime_desktop_database_update 269 fdo-mime_desktop_database_update
285 fdo-mime_mime_database_update 270 fdo-mime_mime_database_update
286 gnome2_icon_cache_update 271 gnome2_icon_cache_update
272 gnome2_schemas_update
273 gnome2_scrollkeeper_update
287} 274}
288 275
276# # FIXME Handle GConf schemas removal
289#gnome2_pkg_prerm() { 277#gnome2_pkg_prerm() {
290# gnome2_gconf_uninstall 278# gnome2_gconf_uninstall
291#} 279#}
292 280
281# @FUNCTION: gnome2_pkg_postrm
282# @DESCRIPTION:
283# Handle scrollkeeper, GSettings, Icons, desktop and mime database updates.
293gnome2_pkg_postrm() { 284gnome2_pkg_postrm() {
294 gnome2_scrollkeeper_update
295 fdo-mime_desktop_database_update 285 fdo-mime_desktop_database_update
296 fdo-mime_mime_database_update 286 fdo-mime_mime_database_update
297 gnome2_icon_cache_update 287 gnome2_icon_cache_update
288 gnome2_schemas_update
289 gnome2_scrollkeeper_update
298} 290}
299
300EXPORT_FUNCTIONS src_unpack src_compile src_install pkg_postinst pkg_postrm

Legend:
Removed from v.1.76  
changed lines
  Added in v.1.119

  ViewVC Help
Powered by ViewVC 1.1.20